=== debian/changelog ===
digikam (4:8.1.0-3~mx23) mx; urgency=medium

  * Rebuild for MX-23

 -- Timothy E. Harris <maintainer@mxrepo.com>  Sun, 14 Jan 2024 14:59:07 -0500

digikam (4:8.1.0-3) unstable; urgency=medium

  [ Steve Robbins ]
  * [93e61c0] Fix GPUMemCopy's use of SSE.

 -- Steve M. Robbins <smr@debian.org>  Thu, 17 Aug 2023 21:50:01 -0500

digikam (4:8.1.0-2) unstable; urgency=medium

  * Team upload.

  [ Pino Toscano ]
  * [81bbd80] Stop using qtwebengine5-dev on mipsel
  * [6a31f7a] Drop the unused libkf5mediawiki-dev build dependency
  * [d1785cc] Update lintian overrides
  * [fb6e052] Drop the no-op dh_clean override
  * [8bc3eab] Switch dh addon and buildsystem from kde to kf5
  * [0f7d0df] Drop the old and unused ${digikam:Conflicts} substvar
  * [3f81830] Remove inactive Uploaders

 -- Pino Toscano <pino@debian.org>  Sat, 22 Jul 2023 07:27:14 +0200

digikam (4:8.1.0-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [7319a55] New upstream version 8.1.0
  * [972063e] Rebase patches
  * [6b86831] update override for libraw
  * [edff063] Enable media player.  Closes: #1004769.

 -- Steve M. Robbins <smr@debian.org>  Fri, 14 Jul 2023 10:01:54 -0500

digikam (4:8.0.0-3) unstable; urgency=medium

  [ Steve Robbins ]
  * [c6f1329] Fix build without mediaplayer.

 -- Steve M. Robbins <smr@debian.org>  Thu, 06 Jul 2023 23:24:32 -0500

digikam (4:8.0.0-2) unstable; urgency=medium

  [ Steve Robbins ]
  * [a8c865a] Add libksanecore-dev dep
  * [e861f33] Disable mediaplayer for upload to unstable.
  * New upstream version.  Closes: #1036738.
    Builds with GCC-13.  Closes: #1037621.
    User able to disable downloading face detection data. Closes: #1028507.

 -- Steve M. Robbins <smr@debian.org>  Thu, 06 Jul 2023 21:20:25 -0500

digikam (4:8.0.0-1) experimental; urgency=medium

  * New upstream version (bug #1036738).
    - Video is enabled again, but it is extremely buggy;
      will often crash digikam.  This is why the upload is to experimental.
    - Because this is only in experimental, bugs addressed are not closed.
  * Now allows user to disable downloading face detection data (bug #1028507).
  * [762413e] Enable media player (bug #1004769).
  * [dddd181] Remove icons for test program "avplayer"
  * [29f967b] Update dependencies.  Disable testing in cmake to avoid
    downloading test data during build.

 -- Steve M. Robbins <smr@debian.org>  Sat, 01 Jul 2023 15:34:14 -0500

digikam (4:7.9.0-2) unstable; urgency=medium

  [ Debian Janitor ]
  * [66f5f14] Trim trailing whitespace.
  * [b7197e6] Fix day-of-week for changelog entries 0.5.1-1, 0.5.0-1.

  [ Steve Robbins ]
  * [312f1c1] Add upstream patch for better spash screen handling.

 -- Steve M. Robbins <smr@debian.org>  Sun, 30 Apr 2023 22:03:02 -0500
